//--------------------------------------------------------------------------
#include <vcl.h>
#include <list.h>
#pragma hdrstop

#include "main.h"
#include "Unit1.h"
#include "repere.h"
#include "box.h"
#include "interval.h"
#include <fstream>
#include "Unit1.h"
extern TForm1 *Form1;
fstream Fout;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//----------------------------------------------------------------------
void TForm1::DrawRoom(repere& R, bool waypoint)
{
  for (int j=0;j<Form1->auv1.N_cercles;j++)
       R.DrawCircle(auv1.cercles_x[j],auv1.cercles_y[j],auv1.cercles_r[j],clWhite,clBlue,2);
  for (int j=0;j<Form1->auv1.N_murs;j++)
       R.DrawLine (auv1.murs_xa[j],auv1.murs_ya[j],auv1.murs_xb[j],auv1.murs_yb[j],clBlack,psSolid,3);
  if (waypoint)
  for (int j=0;j<controller1.N_mission_points;j++)
       if (controller1.mission_mode[j]=='g')
          {  if (j>controller1.i_mission) R.DrawPoint2(controller1.mission_1[j],controller1.mission_2[j],clPurple,6);
             if (j<controller1.i_mission) R.DrawPoint2(controller1.mission_1[j],controller1.mission_2[j],clGreen,4);
             if (j==controller1.i_mission) R.DrawPoint2(controller1.mission_1[j],controller1.mission_2[j],clRed,8);
          }
  R.image->Refresh();
} ;
//----------------------------------------------------------------------
void TForm1::DrawRobot1(repere& R,double& x,double& y,double& theta, double& d,TColor couleur,int epais)
{      double ux=cos(theta);
       double uy=sin(theta);
       //R.DrawLine(x-0.2*ux,y-0.2*uy,x+0.2*ux,y+0.2*uy,clBlack,psSolid,3);
       R.DrawCircle(x,y,d,clGray,clGray,1);
       R.image->Refresh();
} ;
//----------------------------------------------------------------------
void TForm1::DrawDataPoint(repere& R,double& y, TColor couleur, double epais)
{      R.DrawPoint (Form1->t,y,couleur,epais);
       R.image->Refresh();
}
//----------------------------------------------------------------------
void TForm1::DrawDataCadre(repere& R,double& y, TColor couleur, double epais)
{      R.DrawPointCadre(Form1->t,y,couleur,0.05,0.2);
       R.image->Refresh();
}
//----------------------------------------------------------------------
void TForm1::DrawDataBar(repere& R,interval& y, TColor couleur)
{      R.DrawLine(Form1->t,y.inf,Form1->t,y.sup,couleur,psSolid,1);
       R.image->Refresh();
}
//----------------------------------------------------------------------
void TForm1::GO()
{ Fout.open("data.txt",fstream::out);
  double u1;double u2;
  auv1=auv();
  int k=0;

  Fout<<"% number of circles"<<'\n';
  Fout<<auv1.cercles_x.size()<<'\n';
  for (int i=0;i<auv1.cercles_x.size();i++)
    Fout<<auv1.cercles_x[i]<<"  "<<auv1.cercles_y[i]<<"  "<<auv1.cercles_r[i]<<'\n';
  Fout<<"% number of wall"<<'\n';
  Fout<<auv1.murs_xa.size()<<'\n';
  for (int i=0;i<auv1.murs_xa.size();i++)
    Fout<<auv1.murs_xa[i]<<"  "<<auv1.murs_ya[i]<<"  "<<auv1.murs_xb[i]<<"  " <<auv1.murs_yb[i]<<'\n';

  double d,boussole,x_mes,y_mes;
  Fout<<"%  k "<<"  x " <<"  y  " <<"  theta  " <<"   v   " <<"  u1  " <<"   u2  " <<"  d   " <<'\n';;


  while (controller1.i_mission<controller1.N_mission_points)     // Dpart de l'AUV
  {   k++;
      Form1->t=Form1->t+Form1->dt;
      //Form1->Memo1->Text="Mission = "+String(controller1.i_mission)+" \r\n ";
      auv1.clock(d,boussole,u1,u2);  // Simulateur
      controller1.clock(u1,u2,auv1.x,auv1.y,auv1.theta);
      Fout<<"  "<<k<<"  " <<auv1.x<<"  " <<auv1.y<<"  "
          <<auv1.theta<<"  " <<auv1.v<<"  " <<u1<<"  " <<u2<<"  " <<d<<'\n';
  }
  Fout.close();
} ;
//----------------------------------------------------------------------












