

#include "auv.h"
#include "Unit1.h"
extern TForm1 *Form1;

//---------------------------------------------------------------------------
char* fgets2(FILE* f,char* line)   //Afin d'ignorer les lignes qui commencent par %
{ char* r;
  do   { r=fgets(line,256,f);}  while ((line[0]=='%')&&(r!= NULL));
  return r;
}
//---------------------------------------------------------------------------
auv::auv()
{    //x =5; y =0; theta =0; v =0.1;
    FILE *f;
    char line[256];
    f = fopen("auv.txt","r");
    fgets2(f,line); sscanf(line,"%lf%lf%lf%lf",&x,&y,&theta,&v);
    fgets2(f,line); sscanf(line,"%d",&N_cercles);
    for (int i=0;i<N_cercles;i++)
        {   double x,y,r;
            fgets2(f,line); sscanf(line,"%lf%lf%lf",&x,&y,&r);
            cercles_x.push_back(x); cercles_y.push_back(y); cercles_r.push_back(r);
        }
    while (fgets2(f,line) != NULL)
        {   double xa,ya,xb,yb;
            sscanf(line,"%lf%lf%lf%lf",&xa,&ya,&xb,&yb);
            murs_xa.push_back(xa);  murs_ya.push_back(ya);
            murs_xb.push_back(xb);  murs_yb.push_back(yb);
            N_murs=murs_xa.size();
        }
    fclose(f);
}
//---------------------------------------------------------------------------
void auv::clock(double& d1, double& theta1, double u1, double u2)
{    double d1a=DistanceSegments(x,y,murs_xa,murs_ya,murs_xb,murs_yb);
     double d1b=DistanceCercles(x,y,cercles_x,cercles_y,cercles_r);
     d1=min(d1a,d1b);
     theta1=theta;
     double ran=1.0*rand()/RAND_MAX;
     d1=d1+(ran-0.5)*0.000001;


     Form1->DrawRoom(Form1->R1,false); Form1->DrawRobot1(Form1->R1,x,y,theta1,d1,clBlack,2);
     Form1->R2.Clean();
     Form1->DrawRoom(Form1->R2,true); Form1->DrawRobot1(Form1->R2,x,y,theta1,d1,clBlack,2);
     Form1->DrawRoom(Form1->R3,true); Form1->R3.image->Refresh();


     Form1->DrawRoom(Form1->R4,false); Form1->R4.DrawPoint(x,y,clGray,2);


     double xp     = x     + Form1->dt*(cos(theta)*v);
     double yp     = y     + Form1->dt*(sin(theta)*v);
     double thetap = theta + Form1->dt*(u2-u1);
     double vp     = v     + Form1->dt*((u1+u2)-v);
     x=xp;y=yp;theta=thetap;v=vp;
}


