

#include "controller.h"
#include "Unit1.h"
extern TForm1 *Form1;
//---------------------------------------------------------------------------
char* fgets2(FILE* f,char* line)   //Afin d'ignorer les lignes qui commencent par %
{ char* r;
  do   { r=fgets(line,256,f);}  while ((line[0]=='%')&&(r!= NULL));
  return r;
}
//---------------------------------------------------------------------------
controller::controller()
  {   compteur=0;
      i_mission=0;
      FILE *f;
      char line[256];
      f = fopen("controller.txt","r");
      fgets2(f,line); sscanf(line,"%d",&N_mission_points);
      for (int i=0;i<N_mission_points;i++)
       { char mode;
         double m1,m2,m3;
         fgets2(f,line); sscanf(line,"%c%lf%lf%lf",&mode,&m1,&m2,&m3);
         mission_mode.push_back(mode);
         mission_1.push_back(m1); mission_2.push_back(m2); mission_3.push_back(m3);
       }
    fclose(f);

}
//---------------------------------------------------------------------------
void controller::clock(double& u1, double& u2, double x,double y,double theta)
{    if (mission_mode[i_mission]=='u')  // Commande en boucle ouverte avec Chrono
     {   compteur=compteur+Form1->dt;
         u1=mission_1[i_mission]; u2=mission_2[i_mission];
         if (compteur>mission_3[i_mission])
           {compteur=0; i_mission++;}
         return;
     }
     double ux,uy,ex,ey,norm_e,omega,a,radius;
     ux=cos(theta);     uy=sin(theta);
     ex=mission_1[i_mission]-x;
     ey=mission_2[i_mission]-y;
     norm_e=sqrt(ex*ex+ey*ey)+0.001;  //0.001 pour viter les divisions par 0

     //if (ux*ex+uy*ey<0) omega=1;  //Si l'AUV n'est pas dans le bon sens : rotation maximale
     //  else omega=fabs((ux*ey-ex*uy)/norm_e); // sinon, la rotation est lie  l'erreur d'angle
     omega=1;
     if (ux*ey-ex*uy<0) omega=-omega; // signe de la rotation, suivant que la cible est  droite ou  gauche
     omega=0.1*omega;

     radius=mission_3[i_mission];
     a=0.1;
     if (norm_e<pow(radius,2))
       {u1=0;u2=0;
        i_mission++;
        }
     u1=a-omega;
     u2=a+omega;
} ;
//---------------------------------------------------------------------------

